{ Programm:    Rastertest
  ~~~~~~~~~
  Sprache:     MaxonPASCAL3 (bzw. KickPascal2.12 & OS 2.0-Includes)
  ~~~~~~~~
  Sinn:        Darstellung eines Raster wie bei z.B. SystemReq.
  ~~~~~
  Autor:       PackMAN
  ~~~~~~       c/o Falk Zhlsdorff
               Lindenberg 66
               D-98693 Ilmenau/Thringen

  Copyright:   FREEWARE,  Nutzung nur in nichtkommerziellen Programmen
  ~~~~~~~~~~              Autor wird in Programm (.dok / Infofenster)
                          erwhnt.                                      

  Kommentar:   spezielle Version fr MAXON
  ~~~~~~~~~~                              
               (nicht fontsensitiv)                                      }  

Program Rastertest;
USES Intuition,Graphics;

VAR   Win     : ^Window;
      Msg     : ^IntuiMessage;
      e       : boolean;
      RP      : p_RastPort;
      pattern : array[0..1] of word;

PROCEDURE SetAfPt(w:p_RastPort;p:Ptr;n:Integer);
BEGIN
 w^.AreaPtrn:=p;
 w^.AreaPtSz:=n;
END;

BEGIN
 Win:=Open_Window(200,0,300,100,$0203,_CLOSEWINDOW,  
         ACTIVATE+WINDOWDRAG+WINDOWDEPTH+RMBTRAP+WINDOWCLOSE,
         'Rastertest  by PackMAN in `94',Nil,0,0,0,0);
                                   { einfaches OS 1.3-Window zum Test } 
 IF Win=Nil THEN  exit;
 e:=false;
 RP:=Win^.RPort;
 pattern[0]:=$AAAA;                { Pattern ausfllen    }
 pattern[1]:=$5555;
 SetAfPt(RP,^pattern,1);           { Pattern setzen       }
 SetAPen(RP,2);                    { Farben fr Raster    } 
 SetBPen(RP,0);
 SetDrMd(RP,JAM2);                 { Schreibmodus setzen  }
 RectFill(RP,3,11,294,97);
 SetAfPt(RP,NIL,0);                { Pattern zurcksetzen }
 REPEAT
  Msg:=Wait_Port(Win^.UserPort);
  Msg:=Get_Msg(Win^.UserPort);
  Reply_Msg(Msg);
  IF Msg^.Class=_CLOSEWINDOW THEN e:=true;
 UNTIL e;
 Close_Window(Win);
 CloseLib(Intuitionbase);
 Closelib(GfxBase);
END.




